classdef Example1 < Context.Kernel
    % a continuous kernel that does not satisfy the conditions of CFF or
    % dSP and is yet simulable - see details in [1]
    %
    % author: Aurlien Garivier
    % reference: [1] Perfect Simulation Scheme For Processes With Long Memory :
    %    A ``Coupling Into And From The Past'' Algorithm, by A. Garivier       
    properties
    end
    
    methods
        function obj = Example1()
            %
            obj.K = 2;
        end
        
        function f = transition(obj, u)
            % good, but somewhat obscure implementation
            k = floor(1/(1-u)^2);
            CSD = Context.Trie.peigne(k);
            values = zeros(1, 2*k+1);
            values(2*(1:k)) = 2;
            values(2*k+1) = 1;
            f = Context.PCfunction(CSD, num2cell(values));
        end
        
        function f = transition2(obj, u)
            % bad but explicit implementation
            k = floor(1/(1-u)^2);
            contexts = cell(1, k+1);
            contexts{1} = [1];
            for j=1:(k-1)
                contexts{j+1} = [1, 2*ones(1, j)];
            end
            contexts{k+1} = 2*ones(1, k);
            CSD = Context.Trie(2, contexts);
            values = cell(1, length(CSD.father));
            leaves = CSD.getLeaves();
            for j=1:k
                values{leaves(j)} = 2;
            end
            values{leaves(end)} = 1;
            f = Context.PCfunction(CSD, values);
        end
    end
    
end

